% checksum = crc(data)  CRC   data  .
% checksum = crc(data,checksum)   CRC.
%
%    data    
%     uint8.   
%     (little-endian).
%
function checksum = crc(data,checksum)
persistent CRC16ANSIoTBL
if isempty(CRC16ANSIoTBL)
    CRC16ANSIoTBL = uint16([
        hex2dec('0000'), hex2dec('C0C1'), hex2dec('C181'), hex2dec('0140'), hex2dec('C301'), hex2dec('03C0'), hex2dec('0280'), hex2dec('C241'),...
        hex2dec('C601'), hex2dec('06C0'), hex2dec('0780'), hex2dec('C741'), hex2dec('0500'), hex2dec('C5C1'), hex2dec('C481'), hex2dec('0440'),...
        hex2dec('CC01'), hex2dec('0CC0'), hex2dec('0D80'), hex2dec('CD41'), hex2dec('0F00'), hex2dec('CFC1'), hex2dec('CE81'), hex2dec('0E40'),...
        hex2dec('0A00'), hex2dec('CAC1'), hex2dec('CB81'), hex2dec('0B40'), hex2dec('C901'), hex2dec('09C0'), hex2dec('0880'), hex2dec('C841'),...
        hex2dec('D801'), hex2dec('18C0'), hex2dec('1980'), hex2dec('D941'), hex2dec('1B00'), hex2dec('DBC1'), hex2dec('DA81'), hex2dec('1A40'),...
        hex2dec('1E00'), hex2dec('DEC1'), hex2dec('DF81'), hex2dec('1F40'), hex2dec('DD01'), hex2dec('1DC0'), hex2dec('1C80'), hex2dec('DC41'),...
        hex2dec('1400'), hex2dec('D4C1'), hex2dec('D581'), hex2dec('1540'), hex2dec('D701'), hex2dec('17C0'), hex2dec('1680'), hex2dec('D641'),...
        hex2dec('D201'), hex2dec('12C0'), hex2dec('1380'), hex2dec('D341'), hex2dec('1100'), hex2dec('D1C1'), hex2dec('D081'), hex2dec('1040'),...
        hex2dec('F001'), hex2dec('30C0'), hex2dec('3180'), hex2dec('F141'), hex2dec('3300'), hex2dec('F3C1'), hex2dec('F281'), hex2dec('3240'),...
        hex2dec('3600'), hex2dec('F6C1'), hex2dec('F781'), hex2dec('3740'), hex2dec('F501'), hex2dec('35C0'), hex2dec('3480'), hex2dec('F441'),...
        hex2dec('3C00'), hex2dec('FCC1'), hex2dec('FD81'), hex2dec('3D40'), hex2dec('FF01'), hex2dec('3FC0'), hex2dec('3E80'), hex2dec('FE41'),...
        hex2dec('FA01'), hex2dec('3AC0'), hex2dec('3B80'), hex2dec('FB41'), hex2dec('3900'), hex2dec('F9C1'), hex2dec('F881'), hex2dec('3840'),...
        hex2dec('2800'), hex2dec('E8C1'), hex2dec('E981'), hex2dec('2940'), hex2dec('EB01'), hex2dec('2BC0'), hex2dec('2A80'), hex2dec('EA41'),...
        hex2dec('EE01'), hex2dec('2EC0'), hex2dec('2F80'), hex2dec('EF41'), hex2dec('2D00'), hex2dec('EDC1'), hex2dec('EC81'), hex2dec('2C40'),...
        hex2dec('E401'), hex2dec('24C0'), hex2dec('2580'), hex2dec('E541'), hex2dec('2700'), hex2dec('E7C1'), hex2dec('E681'), hex2dec('2640'),...
        hex2dec('2200'), hex2dec('E2C1'), hex2dec('E381'), hex2dec('2340'), hex2dec('E101'), hex2dec('21C0'), hex2dec('2080'), hex2dec('E041'),...
        hex2dec('A001'), hex2dec('60C0'), hex2dec('6180'), hex2dec('A141'), hex2dec('6300'), hex2dec('A3C1'), hex2dec('A281'), hex2dec('6240'),...
        hex2dec('6600'), hex2dec('A6C1'), hex2dec('A781'), hex2dec('6740'), hex2dec('A501'), hex2dec('65C0'), hex2dec('6480'), hex2dec('A441'),...
        hex2dec('6C00'), hex2dec('ACC1'), hex2dec('AD81'), hex2dec('6D40'), hex2dec('AF01'), hex2dec('6FC0'), hex2dec('6E80'), hex2dec('AE41'),...
        hex2dec('AA01'), hex2dec('6AC0'), hex2dec('6B80'), hex2dec('AB41'), hex2dec('6900'), hex2dec('A9C1'), hex2dec('A881'), hex2dec('6840'),...
        hex2dec('7800'), hex2dec('B8C1'), hex2dec('B981'), hex2dec('7940'), hex2dec('BB01'), hex2dec('7BC0'), hex2dec('7A80'), hex2dec('BA41'),...
        hex2dec('BE01'), hex2dec('7EC0'), hex2dec('7F80'), hex2dec('BF41'), hex2dec('7D00'), hex2dec('BDC1'), hex2dec('BC81'), hex2dec('7C40'),...
        hex2dec('B401'), hex2dec('74C0'), hex2dec('7580'), hex2dec('B541'), hex2dec('7700'), hex2dec('B7C1'), hex2dec('B681'), hex2dec('7640'),...
        hex2dec('7200'), hex2dec('B2C1'), hex2dec('B381'), hex2dec('7340'), hex2dec('B101'), hex2dec('71C0'), hex2dec('7080'), hex2dec('B041'),...
        hex2dec('5000'), hex2dec('90C1'), hex2dec('9181'), hex2dec('5140'), hex2dec('9301'), hex2dec('53C0'), hex2dec('5280'), hex2dec('9241'),...
        hex2dec('9601'), hex2dec('56C0'), hex2dec('5780'), hex2dec('9741'), hex2dec('5500'), hex2dec('95C1'), hex2dec('9481'), hex2dec('5440'),...
        hex2dec('9C01'), hex2dec('5CC0'), hex2dec('5D80'), hex2dec('9D41'), hex2dec('5F00'), hex2dec('9FC1'), hex2dec('9E81'), hex2dec('5E40'),...
        hex2dec('5A00'), hex2dec('9AC1'), hex2dec('9B81'), hex2dec('5B40'), hex2dec('9901'), hex2dec('59C0'), hex2dec('5880'), hex2dec('9841'),...
        hex2dec('8801'), hex2dec('48C0'), hex2dec('4980'), hex2dec('8941'), hex2dec('4B00'), hex2dec('8BC1'), hex2dec('8A81'), hex2dec('4A40'),...
        hex2dec('4E00'), hex2dec('8EC1'), hex2dec('8F81'), hex2dec('4F40'), hex2dec('8D01'), hex2dec('4DC0'), hex2dec('4C80'), hex2dec('8C41'),...
        hex2dec('4400'), hex2dec('84C1'), hex2dec('8581'), hex2dec('4540'), hex2dec('8701'), hex2dec('47C0'), hex2dec('4680'), hex2dec('8641'),...
        hex2dec('8201'), hex2dec('42C0'), hex2dec('4380'), hex2dec('8341'), hex2dec('4100'), hex2dec('81C1'), hex2dec('8081'), hex2dec('4040')  ]);
end
if nargin < 2
    checksum = uint16(65535);
end
if ~isa(data,'uint8')
    bytes = typecast(data,'uint8');
else
    bytes = data;
end
for k = 1:length(bytes)
    index = bitxor(uint8(bitand(checksum,uint16(255))),bytes(k));
    a = bitshift(checksum,-8);
    b = CRC16ANSIoTBL(uint16(index)+1);
    checksum = bitxor(a,b);
end
return
