%          . 
%   ( ).
function nimonitor(port, filt, mode)

debug = 0;  %      
VSS = 2.5;
%magnification = (1 * 1/(2^31) * VSS); %2.048/2^31/128*1e6; %     
magnification = 1; 

if ~nargin
    port = niopen('COM13');
end
if nargin < 2
    filt = 0;
    mode = 1;
end
% if ischar(filt)
%     filt = str2double(filt);
% end
if filt
    load devfilter A B
    boundary = zeros(max(length(A),length(B))-1,6);
end

flushinput(port); 

if ( (mode > 0) && (mode < 4) )
    
    if (mode == 1)
        strComand = sprintf('/put/memory?address=52&value=%d&', mode);
        fwrite(port, strComand);
        pause(1);
        strComand = sprintf('/put/memory?address=52&value=%d&', mode);
        fwrite(port, strComand);
    else
        strComand = sprintf('/put/memory?address=52&value=%d&', mode);
        fwrite(port, strComand); 
        pause(1);
        fwrite(port, strComand);
    end
    pause(1);
%     pause(1);
%     readasync(port);
%     count = port.BytesAvailable;
%     if (count > 0)
%         disp('Channel settings:');
%         char(fread(port, count)')
%     end
%     pause(1);
else
    error('Mode error');
end

fread(port, 11);    %     

frequency = 250;
frame = 250 * 8;
window = repmat(hann(frame),[1, 6]);

windowPower = mean(window.^2);
frequencies = 0:(frequency/frame):40;

%% Plots initialization
h = zeros(1,6);
figure
for p = 1:12
    subplot(6,2,p);
    h(p) = plot(0,0);
    if rem(p-1,2) == 0
        set(h(p),'XData',(0:frame-1)/frequency,'YData',zeros(1,frame))
    else
        set(h(p),'XData',frequencies,'YData',zeros(1,length(frequencies)))
    end
end
maximize

data = zeros(0,6);
while 1
    %   
    block = nistream(port, debug);
    block = double(block(:,1:end-1));
    if filt
        [block,boundary] = filter(B, A, block, boundary);
    end
    data = [ data; block ]; %#ok<AGROW>
    
    %   
    if size(data,1) < frame, continue,end
    
    block = data(end-frame+(1:frame),:);
    if filt
        spect = abs( fft(block.*window) );
        spect = spect / sqrt(windowPower);
    else
        spect = abs(fft(block));
        spect(1,:) = 0;
    end
    
    try
        for p = 1:6
            set( h(p * 2 - 1), 'YData', (magnification * block(:,p)') )
            set( h(p * 2), 'YData', (magnification * 2 / length(spect) * spect( 1 : length(frequencies), p )') )
        end
        drawnow
    catch
        save nimonitor data magnification filt
        break
    end
end
