% nimovie(s,movie,frameRate[,duration,color])   movie 
%   frameRate.  movie   
%  [X,Y,N],  X -  , Y -  ,  N -
%  .   duration,    
%     .  color  
%     (0..7).
%
% nimovie(port,fileName[,frameRate,duration,color])   
%  COM  port     fileName  movie,
% frameRate, duration  color.  frameRate, duration  color 
%  /   .
%
% nimovie      .
%
function nimovie(port,movie,frameRate,duration,color)
persistent s t frames m counter

if ~nargin %  
    if ~isempty(t)
        stop(t)
        img = zeros(size(m,1),size(m,2));
        niimage(s,img);
    end
    return
elseif nargin == 1 %    
    movie = randi(8,[8 8 10])-1;
    frameRate = 10;
    duration = 10;
elseif ischar(port) %     
    p = load(movie);
    movie = p.movie;
    if isfield(p,'frameRate')
        frameRate = p.frameRate;
    end
    if isfield(p,'duration')
        duration = p.duration;
    end
    if isfield(p,'color')
        color = p.color;
    end
elseif nargin == 2 %   
    counter = counter + 1;
    if counter <= frames
        img = m(:,:,1+rem(counter-1,size(m,3)));
    else
        img = zeros(size(m,1),size(m,2));
    end
    niimage(s,img);
    return
end

if ~isempty(t)
    stop(t)
end

if ischar(port);
    port = niopen(port);
end
if exist('frameRate','var')
    if ischar(frameRate)
        frameRate = str2double(frameRate);
    end
else
    frameRate = 1;
end
if exist('duration','var') && ischar(duration)
    duration = str2double(duration);
end
if exist('color','var')
    if ischar(color)
        color = str2double(color);
    end
    movie = (movie~=0)*color;
end

m = movie;
s = port;
if exist('duration','var')
    frames = round(duration*frameRate);
else
    frames = size(movie,3);
end
counter = 0;
t = timer('ExecutionMode','fixedRate','Period',1/frameRate,...
    'TimerFcn',@nimovie,'TasksToExecute',frames+1);
start(t)

return
