% C      (signal)   
%  (vars).     ,    .
%     pointers.
function [signal,vars,pointers] = nistream(port,debug)

if nargin < 2
    debug = 0;
end

if ~nargin %  
    port = niopen('COM4');
    while (1)
        signal = nistream(port);
        disp(signal)
    end
end

nChannels = 8;

signal = zeros(0,nChannels,'int32');
pointers = zeros(0,4,'uint8');
while 1
    %    - 
    header(1:3,1) = uint8(fread(port,3,'uint8'));
    while (not(all(header(1:3,1)==[1,28,32]')))
        header(1:2,1) = header(2:3,1);
        header(3,1) = uint8(fread(port,1,'uint8'));
    end
    header(4:9) = uint8(fread(port,6,'uint8'));
    assert(all(header(1:3,1)==[1,28,32]'))
    pointers(end+1,:) = header(4:7)'; %#ok<AGROW>
    len = swapbytes(typecast(header(8:9),'uint16'));
    assert(rem(len,4)==0)
    data = uint8(fread(port,double(len),'uint8'));
    check = uint16(fread(port,1,'uint16'));
    check = swapbytes(check);
    assert(check==crc([header;data]))
    
    %    
    data = swapbytes(typecast(data,'int32'));
    assert(rem(numel(data),nChannels)==0)
    data = reshape(data,[nChannels,numel(data)/nChannels])';
    signal = [ signal; data ]; %#ok<AGROW>
    
    %    - 
    header = uint8(fread(port,9,'uint8'));
%     while (not(all(header(1:3,1)==[1,28,64]')))
%         header(1:2,1) = header(2:3,1);
%         header(3,1) = uint8(fread(port,1,'uint8'));
%     end
    assert(all(header(1:3)==[1,28,64]'))
    vars.successPerf = header(4);
    vars.falsePerf = header(5);
    vars.checksum = swapbytes(typecast(header(6:7),'uint16'));
    len = swapbytes(typecast(header(8:9),'uint16'));
    assert(mod(len,16)==0)
    if len ~= 0
        data = uint8(fread(port,double(len),'uint8'));
        mat = reshape(data,[16,len/16]);
        for n = 1:size(mat,2)
            clock = swapbytes(typecast(mat(1:4,n),'uint32'));
            name = char(mat(5:14,n)');
            code = mat(15,n);
            if debug
                fprintf('%s %i %i\n',name,clock,code);
            end
        end
        if debug
            fprintf('-----------------------\n');
        end
    else
        data = zeros(1,0);
    end
    check = uint16(fread(port,1,'uint16'));
    check = swapbytes(check);
    assert(check==crc([header;data]))
    
    %     ,  
    if port.BytesAvailable < 11
        break
    end
end

return
