% C      (signal)   
%  (vars).     ,    .
%     pointers.
function [signal,vars,pointers,all_name,all_clock,all_code] = nistream(port)
% port.BytesAvailable


all_clock=[];
all_name=[];
all_code=[];

if ~nargin %  
    port = niopen('COM4');
    while (1)
        signal = nistream(port);
        disp(signal)
    end
end


nChannels = 8;

signal = zeros(0,nChannels,'int32');
pointers = zeros(0,4,'uint8');

  if port.BytesAvailable>0
        port.BytesAvailable
  end
    
while 1
    
   
    %    - 
    header = uint8(fread(port,9,'uint8'));
    assert(all(header(1:3)==[1,28,32]'))
    pointers(end+1,:) = header(4:7)';
    len = swapbytes(typecast(header(8:9),'uint16'));
    
    assert(rem(len,4)==0)
    
   
    data = uint8(fread(port,double(len),'uint8'));
   check = uint16(fread(port,1,'uint16'));
    check = swapbytes(check);
    
    assert(check==crc([header;data]))
    
    
    %    
    data = swapbytes(typecast(data,'int32'));
    
    assert(rem(numel(data),nChannels)==0)
    data = reshape(data,[nChannels,numel(data)/nChannels])';
    signal = [ signal; data ];
    
    %    - 
    header = uint8(fread(port,9,'uint8'));
    
    assert(all(header(1:3)==[1,28,64]'))
    
    vars.successPerf = header(4);
    vars.falsePerf = header(5);
    vars.checksum = swapbytes(typecast(header(6:7),'uint16'));
    len = swapbytes(typecast(header(8:9),'uint16'));
    assert(mod(len,16)==0)
    if len ~= 0
        data = uint8(fread(port,double(len),'uint8'));
        
        mat = reshape(data,[16,len/16]);
        
        for n = 1:size(mat,2)
            clock = swapbytes(typecast(mat(1:4,n),'uint32'));
            name = char(mat(5:14,n)');
            code = mat(15,n);
            
            all_clock=[all_clock; clock]; %#ok<*AGROW>
            all_name=[all_name; name];
            all_code=[all_code; code];
            
            %             fprintf('%s %i %i\n',name,clock,code);
        end
        %         fprintf('-----------------------\n');
    end
    check = uint16(fread(port,1,'uint16'));
    check = swapbytes(check);
    assert(check==crc([header;data]))
    
    %     ,  
    if port.BytesAvailable < 11
        break
    end
end

return
